{
  let buf = Buffer.create 100
  let add_string = Buffer.add_string buf
  let add_char = Buffer.add_char buf
  let contents () = Buffer.contents buf
  let clear () = Buffer.clear buf
  let flush () = 
    let s = contents () in
    clear ();
    s
  let line = ref 1
  let char = ref 1
  let newfile () =
    line := 1;
    char := 1
  let location () = `Location (!line, !char)
  let newline () =
    add_char '\n';
    incr line;
    char := 1
  let newchars n = char := !char + n
  let init () = 
    clear ();
    newfile ()
  let add s =
    add_string s;
    newchars (String.length s)
}
rule text b = parse
| "###" { add (if b then "##" else "###"); newchars 1; text b lexbuf }
| "##"  { newchars 2; 
	  let t = `Text (flush ()) in
	  let loc = location () in
	  t :: loc :: code b lexbuf }
| "\r\n"
| '\r'
| '\n'   { newline (); text b lexbuf }
| eof    { [`Text (flush ())] }
| _      { add (Lexing.lexeme lexbuf); text b lexbuf }
and code b = parse
| "###"  { add (if b then "##" else "###"); newchars 1; code b lexbuf }
| "##"   { newchars 2;
	   let e = `Code (flush ()) in
	   let loc = location () in
	   e :: loc :: text b lexbuf }
| "\r\n"
| '\r'
| '\n'   { newline (); code b lexbuf }
| eof    { [`Code (flush ())] }
| _      { add (Lexing.lexeme lexbuf); code b lexbuf }

{
  let get ?(reduce_sharps = false) lexbuf =
    init ();
    `Location (1, 1) :: text reduce_sharps lexbuf
}
